/*
  AppWindow.java

  Copyright (c) 1998 Geometrek
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.deck;

import java.awt.*;
import java.applet.*;

/**
 * special Window to hold images of avatars
 * 
 */
public class AppWindow extends Window {
  private GridBagLayout GBL;
  private int iHeight;
  private int iWidth;
  private Image iImg;
  private Frame app;
  private Avatarcom ac;
  private Panel P1;
  private Panel P2;
  private Button HB;
  private ImgPanel IP;

  public AppWindow(){
  }

  public AppWindow( Frame parent, Color BG, Color FG ){
    this.app = parent;
    this.ac = (Avatarcom)parent;
    GBL = new GridBagLayout();
    setLayout( GBL );
    IP = new ImgPanel( (Applet)parent );
    GBL.setConstraints( IP, makeGridCons( 0, 0, 1, 1, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.NORTH, 1, 1, 0, 0, 0, 0 ) );
    add( IP ); 
	P1 = new Panel();
    GBL.setConstraints( P1, makeGridCons( 0, 1, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 1, 1, 0, 0, 0, 0 ) );
    add( P1 );
    HB = new Button( "Close" );
	GBL.setConstraints( HB, makeGridCons( 2, 1, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.SOUTH, 1, 1, 0, 0, 0, 0 ) );
    add( HB );
    P2 = new Panel();
	GBL.setConstraints( P1, makeGridCons( 3, 1, 1, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.EAST, 1, 1, 0, 0, 0, 0 ) );
    add( P2 );
    setBackgroundColor ( BG );
    setForegroundColor ( FG );
    }

 public void setBackgroundColor( Color clr ){
 P1.setBackground( clr );
 P2.setBackground( clr );
 HB.setBackground( clr );
 IP.setBackground( clr );
 setBackground( clr );
 }
 
  public void setForegroundColor( Color clr ){
 //Panel1.setForeground( clr );
// Panel2.setForeground( clr );
 HB.setForeground( clr );
// ImgPanel.setForeground( clr );
// setForeground( clr );
 }

  public void setImage( Image img ){
   IP.setImage( img );
  }

  public boolean handleEvent( Event evt ){
    if( evt.id == evt.WINDOW_DESTROY ){
      app.destroy();
      dispose();
      System.exit(0);
      return true;
    }
    return false;
  }

 public GridBagConstraints makeGridCons( int x, int y, int dx, int dy, double wx, double wy, int fill, int anch, int it, int il, int ib, int ir, int px, int py )
  {
    GridBagConstraints cons = new GridBagConstraints();

    cons.weightx    = wx;
    cons.weighty    = wy;
    cons.gridx      = x;
    cons.gridy      = y;
    cons.gridwidth  = dx;
    cons.gridheight = dy;
    cons.fill       = fill;
    cons.anchor     = anch;
    cons.insets     = new Insets( it, il, ib, ir );
    cons.ipadx      = px;
    cons.ipady      = py;

    return cons;
  }

 }
