/**
 MailThread.java
 
 Copyright (C) 2001 Geometrek
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.server;

import java.io.*;
import java.net.*;
import java.util.*;
import matrix.*;

/**
 * manages a connection to a certain user. There is one for each user who
 * connects with the Matrix server. This class also maintains the objects
 * created by a user.
 *
 * @version 1.1
 */
public class MailThread implements Runnable {
	
	protected MatrixD daemon;
 protected Vector mailbag;
	protected Connection connection;
	
	/**
	 * creates a new ServerThread to manage the connection with one
	 * client. It creates the necessary Thread object and starts the
	 * thread.  */
	public MailThread(MatrixD daemon, Connection connection) {
  mailbag = new Vector();
		this.connection = connection;	
		this.daemon = daemon; 
		runner = new Thread( this );
		runner.start();
	}

	/**
	 * returns the clients name
	 */

 public void getMail( Message msg ){
   synchronized( mailbag ){
        mailbag.addElement( msg );
        mailbag.notify();
       }
      }

	/**
	 * handles the connection. First it calls login, then continues with a loop, polling the
	 * connection for new messages and handling the client requests.
	 */
	public void run() {
		Message msg;
      while( Thread.currentThread() == runner ){
        try{
          if(!mailbag.isEmpty()){
            synchronized( mailbag ){
              msg =(Message) mailbag.firstElement();
              mailbag.removeElementAt(0);
            }
            daemon.deliverMail( msg );
          }
          else {
            synchronized( mailbag ){
               Mailbag.wait();
            }
          }
        }
        catch(InterruptedException e){}
        catch(Exception e){
          System.out.println("msgBuffer Error "+e);
        }
      }
	}
	
	/**
	 * tells the client to send new updates for object with name name.
	 * Tests whether this client holds this object and sends an update
	 * messge if so.
	 *
	 * @param name the name of the object
	 */    

	public void close() {
	     runner = null;
      synchronized( mailbag ){
        mailbag.notify();
      }
	  }
 }
