/*
 * Log.java
 * by Frederik Schorr
 * with changes by Geometrek
 *  This file is part of DeepMatrix V1.
 *
 *  DeepMatrix V1 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix V1 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package matrix.server;

import matrix.*;
import matrix.vrml.*;
import java.io.*;
import java.text.*;
import java.util.*;

/**
 * Logs messages with timestamps and thread ids to file.
 * This class was developed by Frederik Schorr during a CS course.
 * I added some minor changes.
 */
public class UserObjData implements Runnable {
    private ServerThread ST;
    private boolean kill = false;
    private boolean exists = false;
    private File OrigFile;
    private String UserName;
    private String objectrecord;
    private Thread runner; 
    private BufferedReader Breader = null;
	

	public UserObjData( String dir, String un, ServerThread st  ) {
         st.objects2 = new Hashtable();
		 ST = st;
         UserName = un; 
		 objectrecord = ( dir + File.separatorChar + "users_objects" + File.separatorChar + UserName + "_Obj.txt" );
		 OrigFile = new File(objectrecord);
		 exists = OrigFile.exists();
         if(exists){
	     runner = new Thread(this,UserName + "_Objs");
         start();
         }
       else {
         ST.log(" " + UserName + " has no objects. ",1);
         }
	}

    public void start(){
    if(runner!=null){ runner.start(); }
    }

    public void run(){
		int index = 0;
         String line, sObjName = null, keyword, sSpecName, sStatus, sLoc, sObjUrl;
 while( Thread.currentThread() == runner ){
        try {
			Breader = new BufferedReader( new FileReader(objectrecord) );
			line = Breader.readLine();
            while(line != null ) {
                if( line.length() > 0 ) {
                    StringTokenizer token = new StringTokenizer(line," ");
                    keyword = token.nextToken();
                    if(keyword.charAt(0) != '#') {                          // No Comment !
					  int iCt = 0;
					   ObjLibVol OLV = new ObjLibVol();
                      String  obj = keyword.toLowerCase();
                        if(obj.equals("object_name")) { 
                            try { 
                            sObjName = token.nextToken();
							 }
                            catch(NoSuchElementException e) {
                    ST.log(" Error parsing "+ objectrecord +" : "+line+"\n\t"+e +" ",1);
                            return;
                            } 
                            try {
                            sObjUrl = token.nextToken();
                            
                            }
							catch(NoSuchElementException e) {
                     ST.log(" Error parsing "+ objectrecord +" position: "+line+"\n\t"+e + " ",1);
                            return;
                            }
                              if( token.hasMoreTokens()) {
                                    try{
                                        iCt = Integer.parseInt( token.nextToken());
                                    }
                                    catch(NumberFormatException e){
                                        System.err.println("Error parsing "+objectrecord+" : "+line+"\n\t"+e);
                                         ST.log(" Error parsing "+objectrecord +" number of objects position: "+line+"\n\t"+e + " ",1);
                                        iCt = 0;
                                         return;
                                    }
                                 }
						   
                           OLV.name = sObjName;
                           OLV.sUrl = sObjUrl;
						   OLV.sOwners = new String [iCt];
                          OLV.sNames = new String [iCt];
                          OLV.sLocations = new String [iCt];
                          OLV.iStatus = new int [iCt];
                             }
                         for( int i = 0; i<iCt; i +=1 ){
                          line = Breader.readLine();
                         if(obj.equals("specific")) {
                          OLV.sOwners[i] = UserName;
						  OLV.sNames[i] = keyword;
                            int iStat = 0;
						   try{
                              iStat = Integer.parseInt( token.nextToken());
                                    }
                                    catch(NumberFormatException e){
                                        System.err.println("Error parsing "+objectrecord+" : "+line+"\n\t"+e);
                                         ST.log(" Error parsing "+ objectrecord+" number of objects position: "+line+"\n\t"+e + " ",1);
                                        iStat = -1;
                                    }
                          OLV.iStatus[i] = iStat;
                          OLV.sLocations[i] = token.nextToken();
                           index +=1;
                         }
                     }
               if(sObjName!=null){  ST.objects2.put( sObjName,OLV ); }
                    }
                 }
                line = Breader.readLine();
                index++;
              }
		   runner = null;
           }
         
        catch(Exception e) { 
            String er = " Error reading "+objectrecord+" in line "+index + " "; 
            ST.log( er, 1 );
			runner = null;
        }
	  
	   finally { 
            try{ 
                if(Breader != null) 
                    Breader.close(); 
            } 
            catch(Exception e) {}
        }
            }
        }
    
  public void stop(){
  runner = null;
   }
  
}
